E. Omkar and Forest 思维,结论
Posted 爷灬傲奈我何123
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了E. Omkar and Forest 思维,结论相关的知识,希望对你有一定的参考价值。
题意:
思路:
我们把#划分成0和1~INF,那么可以发现所有方案都是合法的,可以发现从0开始的点的值都是单调递增的。可以发现是个多源汇的最短路问题,所有不是0的点都是到最近的0点的曼哈顿距离,除了整个图都不是0的情况。特判一下,所以方案数是2^cnt-(cnt==size)。
solution:
#include<bits/stdc++.h>
#define IL inline
#define x first
#define y second
typedef long long ll;
using namespace std;
#define int long long
const int mod=1e9+7;
int qmi(int a,int b)
{
int res=1;
while(b)
{
if(b&1) res=res*a%mod;
b>>=1;
a=a*a%mod;
}
return res;
}
char g[2020][2020];
signed main()
{
int t;
cin>> t;
while(t--)
{
int n,m;
cin >> n >>m;
for(int i=0;i<n;i++) scanf("%s",g[i]);
int cnt=0;
for(int i=0;i<n;i++)
for(int j=0;j<m;j++)
cnt+=(g[i][j]=='#');
cout<<((qmi(2,cnt)-(cnt==n*m))%mod+mod)%mod<<endl;
}
return 0;
}
以上是关于E. Omkar and Forest 思维,结论的主要内容,如果未能解决你的问题,请参考以下文章
E. Omkar and Forest——Codeforces Round #724 (Div. 2)
E. Omkar and Forest——Codeforces Round #724 (Div. 2)
[Codeforces 1586] Omkar and Determination | 思维前缀和
前缀和思维C. Omkar and Determination